#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include <kysec/kysec_communicate.h>
#include <kysecwhlist/kysec_whlist.h>

int main(int argc, char *argv[])
{
	int ret = 0;
	struct object_list list;
	struct object_entry *item = NULL;
	int mesg_type = LABEL_INIT;

	//初始化执行控制hash值
	ret = kysec_whlist_load(0, NULL, &list);
	if (ret != 0)
		fprintf(stderr, "get exectl list failed\n");
	else	{
		SLIST_FOREACH(item, &list, entries)	{
			if (item->object.exectl == exectl_sign_unknown)
				continue;

			ret = kysec_hash_communicate_with_kernel(mesg_type, item->object.hash, item->object.exectl + 1);
			if (ret != 0)
				fprintf(stderr, "kysec init hash to kernel failed, file = %s, hash = %s, exectl = %d\n", 
				item->object.fpath, item->object.hash, item->object.exectl);
		}

		kysec_whlist_objects_free(&list);
	}

	//初始化内核模块hash值
	ret = kysec_whlist_load(2, NULL, &list);
	if (ret != 0)
		fprintf(stderr, "get kmod protect list failed\n");
	else	{
		SLIST_FOREACH(item, &list, entries)	{			
			if (item->object.exectl == exectl_sign_unknown)
				continue;

			ret = kysec_hash_communicate_with_kernel(mesg_type, item->object.hash, item->object.exectl + 1);
			if (ret != 0)
				fprintf(stderr, "kysec init hash to kernel failed, file = %s, hash = %s, exectl = %d\n", 
				item->object.fpath, item->object.hash, item->object.exectl);
		}

		kysec_whlist_objects_free(&list);
	}

	return 0;
}
